]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: check openssl prequisite for add_gpgsm_home
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115
116 add_gnupg_home ()
117 {
118     [ -e "${GNUPGHOME}/gpg.conf" ] && return
119     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120     at_exit_function _gnupg_exit
121     mkdir -p -m 0700 "$GNUPGHOME"
122     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123     test_debug "cat $GNUPGHOME/import.log"
124     if (gpg --quick-random --version >/dev/null 2>&1) ; then
125         echo quick-random >> "$GNUPGHOME"/gpg.conf
126     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
128     fi
129     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
130
131     # Change this if we ship a new test key
132     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
135 }
136
137 add_gpgsm_home ()
138 {
139     test_require_external_prereq openssl
140
141     local fpr
142     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
143     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
144     at_exit_function _gnupg_exit
145     mkdir -p -m 0700 "$GNUPGHOME"
146     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
147         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
148         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
149               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
150     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
151     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
152     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
153     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
154     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
155     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
156               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
157     test_debug "cat $GNUPGHOME/import.log"
158 }
159
160 # Each test should start with something like this, after copyright notices:
161 #
162 # test_description='Description of this test...
163 # This test checks if command xyzzy does the right thing...
164 # '
165 # . ./test-lib.sh || exit 1
166
167 color=maybe
168
169 while test "$#" -ne 0
170 do
171         case "$1" in
172         -d|--debug)
173                 debug=t; shift ;;
174         -i|--immediate)
175                 immediate=t; shift ;;
176         -h|--help)
177                 help=t; shift ;;
178         -v|--verbose)
179                 verbose=t; shift ;;
180         -q|--quiet)
181                 quiet=t; shift ;;
182         --with-dashes)
183                 with_dashes=t; shift ;;
184         --no-color)
185                 color=; shift ;;
186         --no-python)
187                 # noop now...
188                 shift ;;
189         --valgrind)
190                 valgrind=t; verbose=t; shift ;;
191         --tee)
192                 shift ;; # was handled already
193         *)
194                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
195         esac
196 done
197
198 if test -n "$debug"; then
199     print_subtest () {
200         printf " %-4s" "[$((test_count - 1))]"
201     }
202 else
203     print_subtest () {
204         true
205     }
206 fi
207
208 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
209
210 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
211                 TERM=$ORIGINAL_TERM &&
212                 export TERM &&
213                 tput bold
214                 tput setaf
215                 tput sgr0
216         ) >/dev/null 2>&1
217 then
218         color=t
219 else
220         color=
221 fi
222
223 if test -n "$color"; then
224         say_color () {
225                 (
226                 TERM=$ORIGINAL_TERM
227                 export TERM
228                 case "$1" in
229                         error) tput bold; tput setaf 1;; # bold red
230                         skip)  tput bold; tput setaf 2;; # bold green
231                         pass)  tput setaf 2;;            # green
232                         info)  tput setaf 3;;            # brown
233                         *) test -n "$quiet" && return;;
234                 esac
235                 shift
236                 printf " "
237                 printf "$@"
238                 tput sgr0
239                 print_subtest
240                 )
241         }
242 else
243         say_color() {
244                 test -z "$1" && test -n "$quiet" && return
245                 shift
246                 printf " "
247                 printf "$@"
248                 print_subtest
249         }
250 fi
251
252 error () {
253         say_color error "error: $*\n"
254         GIT_EXIT_OK=t
255         exit 1
256 }
257
258 say () {
259         say_color info "$*"
260 }
261
262 test "${test_description}" != "" ||
263 error "Test script did not set test_description."
264
265 if test "$help" = "t"
266 then
267         echo "Tests ${test_description}"
268         exit 0
269 fi
270
271 test_description_printed=
272 print_test_description ()
273 {
274         test -z "$test_description_printed" || return 0
275         echo
276         echo $this_test: "Testing ${test_description}"
277         test_description_printed=1
278 }
279 if [ -z "$NOTMUCH_TEST_QUIET" ]
280 then
281         print_test_description
282 fi
283
284 test_failure=0
285 test_count=0
286 test_fixed=0
287 test_broken=0
288 test_success=0
289
290 declare -a _exit_functions=()
291
292 at_exit_function () {
293         _exit_functions=($1 ${_exit_functions[@]/$1})
294 }
295
296 rm_exit_function () {
297         _exit_functions=(${_exit_functions[@]/$1})
298 }
299
300 _exit_common () {
301         code=$?
302         trap - EXIT
303         set +ex
304         for _fn in ${_exit_functions[@]}; do $_fn; done
305         rm -rf "$TEST_TMPDIR"
306 }
307
308 trap_exit () {
309         _exit_common
310         if test -n "$GIT_EXIT_OK"
311         then
312                 exit $code
313         else
314                 exec >&6
315                 say_color error '%-6s' FATAL
316                 echo " $test_subtest_name"
317                 echo
318                 echo "Unexpected exit while executing $0. Exit code $code."
319                 exit 1
320         fi
321 }
322
323 trap_signal () {
324         _exit_common
325         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
326         exit $code
327 }
328
329 die () {
330         _exit_common
331         exec >&6
332         say_color error '%-6s' FATAL
333         echo " $*"
334         echo
335         echo "Unexpected exit while executing $0."
336         exit 1
337 }
338
339 GIT_EXIT_OK=
340 # Note: TEST_TMPDIR *NOT* exported!
341 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
342 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
343 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
344 trap 'trap_exit' EXIT
345 trap 'trap_signal' HUP INT TERM
346
347 # Deliver a message with emacs and add it to the database
348 #
349 # Uses emacs to generate and deliver a message to the mail store.
350 # Accepts arbitrary extra emacs/elisp functions to modify the message
351 # before sending, which is useful to doing things like attaching files
352 # to the message and encrypting/signing.
353 emacs_deliver_message ()
354 {
355     local subject body smtp_dummy_pid smtp_dummy_port
356     subject="$1"
357     body="$2"
358     shift 2
359     # before we can send a message, we have to prepare the FCC maildir
360     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
361     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
362     smtp_dummy_pid= smtp_dummy_port=
363     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
364     test -n "$smtp_dummy_pid" || return 1
365     test -n "$smtp_dummy_port" || return 1
366
367     test_emacs \
368         "(let ((message-send-mail-function 'message-smtpmail-send-it)
369                (mail-host-address \"example.com\")
370                (smtpmail-smtp-server \"localhost\")
371                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
372            (notmuch-mua-mail)
373            (message-goto-to)
374            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
375            (message-goto-subject)
376            (insert \"${subject}\")
377            (message-goto-body)
378            (insert \"${body}\")
379            $*
380            (notmuch-mua-send-and-exit))"
381
382     # In case message was sent properly, client waits for confirmation
383     # before exiting and resuming control here; therefore making sure
384     # that server exits by sending (KILL) signal to it is safe.
385     kill -9 $smtp_dummy_pid
386     notmuch new >/dev/null
387 }
388
389 # Pretend to deliver a message with emacs. Really save it to a file
390 # and add it to the database
391 #
392 # Uses emacs to generate and deliver a message to the mail store.
393 # Accepts arbitrary extra emacs/elisp functions to modify the message
394 # before sending, which is useful to doing things like attaching files
395 # to the message and encrypting/signing.
396 #
397 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
398 # at the head of the argument list, they are sent directly to "notmuch
399 # new" after message delivery
400 emacs_fcc_message ()
401 {
402     local nmn_args subject body
403     nmn_args=''
404     while [[ "$1" =~ ^-- ]]; do
405         nmn_args="$nmn_args $1"
406         shift
407     done
408     subject="$1"
409     body="$2"
410     shift 2
411     # before we can send a message, we have to prepare the FCC maildir
412     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
413
414     test_emacs \
415         "(let ((message-send-mail-function (lambda () t))
416                (mail-host-address \"example.com\"))
417            (notmuch-mua-mail)
418            (message-goto-to)
419            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
420            (message-goto-subject)
421            (insert \"${subject}\")
422            (message-goto-body)
423            (insert \"${body}\")
424            $*
425            (let ((mml-secure-smime-sign-with-sender t)
426                  (mml-secure-openpgp-sign-with-sender t))
427              (notmuch-mua-send-and-exit)))" || return 1
428     notmuch new $nmn_args >/dev/null
429 }
430
431 # Add an existing, fixed corpus of email to the database.
432 #
433 # $1 is the corpus dir under corpora to add, using "default" if unset.
434 #
435 # The default corpus is based on about 50 messages from early in the
436 # history of the notmuch mailing list, which allows for reliably
437 # testing commands that need to operate on a not-totally-trivial
438 # number of messages.
439 add_email_corpus ()
440 {
441     local corpus
442     corpus=${1:-default}
443
444     rm -rf ${MAIL_DIR}
445     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
446     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
447 }
448
449 test_begin_subtest ()
450 {
451     if [ -n "$inside_subtest" ]; then
452         exec 1>&6 2>&7          # Restore stdout and stderr
453         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
454     fi
455     test_subtest_name="$1"
456     test_reset_state_
457     # Redirect test output to the previously prepared file descriptors
458     # 3 and 4 (see below)
459     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
460     exec >&3 2>&4
461     inside_subtest=t
462 }
463
464 # Pass test if two arguments match
465 #
466 # Note: Unlike all other test_expect_* functions, this function does
467 # not accept a test name. Instead, the caller should call
468 # test_begin_subtest before calling this function in order to set the
469 # name.
470 test_expect_equal ()
471 {
472         local output expected testname
473         exec 1>&6 2>&7          # Restore stdout and stderr
474         if [ -z "$inside_subtest" ]; then
475                 error "bug in the test script: test_expect_equal without test_begin_subtest"
476         fi
477         inside_subtest=
478         test "$#" = 2 ||
479         error "bug in the test script: not 2 parameters to test_expect_equal"
480
481         output="$1"
482         expected="$2"
483         if ! test_skip "$test_subtest_name"
484         then
485                 if [ "$output" = "$expected" ]; then
486                         test_ok_
487                 else
488                         testname=$this_test.$test_count
489                         echo "$expected" > $testname.expected
490                         echo "$output" > $testname.output
491                         test_failure_ "$(diff -u $testname.expected $testname.output)"
492                 fi
493     fi
494 }
495
496 # Like test_expect_equal, but takes two filenames.
497 test_expect_equal_file ()
498 {
499         local file1 file2 testname basename1 basename2
500         exec 1>&6 2>&7          # Restore stdout and stderr
501         if [ -z "$inside_subtest" ]; then
502                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
503         fi
504         inside_subtest=
505         test "$#" = 2 ||
506         error "bug in the test script: not 2 parameters to test_expect_equal_file"
507
508         file1="$1"
509         file2="$2"
510         if ! test_skip "$test_subtest_name"
511         then
512                 if diff -q "$file1" "$file2" >/dev/null ; then
513                         test_ok_
514                 else
515                         testname=$this_test.$test_count
516                         basename1=`basename "$file1"`
517                         basename2=`basename "$file2"`
518                         cp "$file1" "$testname.$basename1"
519                         cp "$file2" "$testname.$basename2"
520                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
521                 fi
522     fi
523 }
524
525 # Like test_expect_equal, but arguments are JSON expressions to be
526 # canonicalized before diff'ing.  If an argument cannot be parsed, it
527 # is used unchanged so that there's something to diff against.
528 test_expect_equal_json () {
529     local script output expected
530     # The test suite forces LC_ALL=C, but this causes Python 3 to
531     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
532     # override Python's stdio encoding defaults.
533     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
534     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
535         || echo "$1")
536     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
537         || echo "$2")
538     shift 2
539     test_expect_equal "$output" "$expected" "$@"
540 }
541
542 # Ensure that the argument is valid JSON data.
543 test_valid_json () {
544     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
545     test_expect_equal "$?" 0
546 }
547
548 # Sort the top-level list of JSON data from stdin.
549 test_sort_json () {
550     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
551         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
552 }
553
554 # test for json objects:
555 # read the source of test/json_check_nodes.py (or the output when
556 # invoking it without arguments) for an explanation of the syntax.
557 test_json_nodes () {
558         local output
559         exec 1>&6 2>&7          # Restore stdout and stderr
560         if [ -z "$inside_subtest" ]; then
561                 error "bug in the test script: test_json_eval without test_begin_subtest"
562         fi
563         inside_subtest=
564         test "$#" > 0 ||
565             error "bug in the test script: test_json_nodes needs at least 1 parameter"
566
567         if ! test_skip "$test_subtest_name"
568         then
569             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
570                 if [ "$?" = 0 ]
571                 then
572                         test_ok_
573                 else
574                         test_failure_ "$output"
575                 fi
576         fi
577 }
578
579 test_emacs_expect_t () {
580         local result
581         test "$#" = 1 ||
582         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
583         if [ -z "$inside_subtest" ]; then
584                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
585         fi
586
587         # Run the test.
588         if ! test_skip "$test_subtest_name"
589         then
590                 test_emacs "(notmuch-test-run $1)" >/dev/null
591
592                 # Restore state after the test.
593                 exec 1>&6 2>&7          # Restore stdout and stderr
594                 inside_subtest=
595
596                 # Report success/failure.
597                 result=$(cat OUTPUT)
598                 if [ "$result" = t ]
599                 then
600                         test_ok_
601                 else
602                         test_failure_ "${result}"
603                 fi
604         else
605                 # Restore state after the (non) test.
606                 exec 1>&6 2>&7          # Restore stdout and stderr
607                 inside_subtest=
608         fi
609 }
610
611 NOTMUCH_NEW ()
612 {
613     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
614 }
615
616 NOTMUCH_DUMP_TAGS ()
617 {
618     # this relies on the default format being batch-tag, otherwise some tests will break
619     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
620 }
621
622 notmuch_drop_mail_headers ()
623 {
624     $NOTMUCH_PYTHON -c '
625 import email, sys
626 msg = email.message_from_file(sys.stdin)
627 for hdr in sys.argv[1:]: del msg[hdr]
628 print(msg.as_string(False))
629 ' "$@"
630 }
631
632 notmuch_exception_sanitize ()
633 {
634     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
635 }
636
637 notmuch_search_sanitize ()
638 {
639     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
640 }
641
642 notmuch_search_files_sanitize ()
643 {
644     notmuch_dir_sanitize
645 }
646
647 notmuch_dir_sanitize ()
648 {
649     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
650 }
651
652 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
653 notmuch_show_sanitize ()
654 {
655     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
656 }
657 notmuch_show_sanitize_all ()
658 {
659     sed \
660         -e 's| filename:.*| filename:XXXXX|' \
661         -e 's| id:[^ ]* | id:XXXXX |' | \
662         notmuch_date_sanitize
663 }
664
665 notmuch_json_show_sanitize ()
666 {
667     sed \
668         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
669         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
670         -e 's|"filename": "signature.asc",||g' \
671         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
672         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
673         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
674 }
675
676 notmuch_emacs_error_sanitize ()
677 {
678     local command
679     command=$1
680     shift
681     for file in "$@"; do
682         echo "=== $file ==="
683         cat "$file"
684     done | sed \
685         -e 's/^\[.*\]$/[XXX]/' \
686         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
687 }
688
689 notmuch_date_sanitize ()
690 {
691     sed \
692         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
693 }
694
695 notmuch_uuid_sanitize ()
696 {
697     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
698 }
699
700 notmuch_built_with_sanitize ()
701 {
702     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
703 }
704
705 notmuch_passwd_sanitize()
706 {
707     ${NOTMUCH_PYTHON} -c'
708 import os, sys, pwd, socket
709
710 pw = pwd.getpwuid(os.getuid())
711 user = pw.pw_name
712 name = pw.pw_gecos.partition(",")[0]
713 fqdn = socket.getfqdn()
714
715 for l in sys.stdin:
716     l = l.replace(user, "USERNAME").replace(fqdn, "FQDN").replace(".(none)","").replace(name, "USER_FULL_NAME")
717     sys.stdout.write(l)
718 '
719 }
720
721 notmuch_config_sanitize ()
722 {
723     notmuch_dir_sanitize | notmuch_built_with_sanitize
724 }
725
726 notmuch_show_part ()
727 {
728     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
729 }
730
731 # End of notmuch helper functions
732
733 # Use test_set_prereq to tell that a particular prerequisite is available.
734 #
735 # The prerequisite can later be checked for by using test_have_prereq.
736 #
737 # The single parameter is the prerequisite tag (a simple word, in all
738 # capital letters by convention).
739
740 test_set_prereq () {
741         satisfied="$satisfied$1 "
742 }
743 satisfied=" "
744
745 test_have_prereq () {
746         case $satisfied in
747         *" $1 "*)
748                 : yes, have it ;;
749         *)
750                 ! : nope ;;
751         esac
752 }
753
754 declare -A test_missing_external_prereq_
755 declare -A test_subtest_missing_external_prereq_
756
757 # declare prerequisite for the given external binary
758 test_declare_external_prereq () {
759         local binary
760         binary="$1"
761         test "$#" = 2 && name=$2 || name="$binary(1)"
762
763         if ! hash $binary 2>/dev/null; then
764                 test_missing_external_prereq_["${binary}"]=t
765                 eval "
766 $binary () {
767         test_subtest_missing_external_prereq_[\"${name}\"]=t
768         false
769 }"
770         fi
771 }
772
773 # Explicitly require external prerequisite.  Useful when binary is
774 # called indirectly (e.g. from emacs).
775 # Returns success if dependency is available, failure otherwise.
776 test_require_external_prereq () {
777         local binary
778         binary="$1"
779         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
780                 # dependency is missing, call the replacement function to note it
781                 eval "$binary"
782         else
783                 true
784         fi
785 }
786
787 # You are not expected to call test_ok_ and test_failure_ directly, use
788 # the text_expect_* functions instead.
789
790 test_ok_ () {
791         if test "$test_subtest_known_broken_" = "t"; then
792                 test_known_broken_ok_
793                 return
794         fi
795         test_success=$(($test_success + 1))
796         if test -n "$NOTMUCH_TEST_QUIET"; then
797                 return 0
798         fi
799         say_color pass "%-6s" "PASS"
800         echo " $test_subtest_name"
801 }
802
803 test_failure_ () {
804         print_test_description
805         if test "$test_subtest_known_broken_" = "t"; then
806                 test_known_broken_failure_ "$@"
807                 return
808         fi
809         test_failure=$(($test_failure + 1))
810         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
811         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
812         return 1
813 }
814
815 test_failure_message_ () {
816         say_color error "%-6s" "$1"
817         echo " $2"
818         shift 2
819         if [ "$#" != "0" ]; then
820                 echo "$@" | sed -e 's/^/        /'
821         fi
822         if test "$verbose" != "t"; then cat test.output; fi
823 }
824
825 test_known_broken_ok_ () {
826         test_reset_state_
827         test_fixed=$(($test_fixed+1))
828         say_color pass "%-6s" "FIXED"
829         echo " $test_subtest_name"
830 }
831
832 test_known_broken_failure_ () {
833         test_reset_state_
834         test_broken=$(($test_broken+1))
835         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
836                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
837         else
838                 test_failure_message_ "BROKEN" "$test_subtest_name"
839         fi
840         return 1
841 }
842
843 test_debug () {
844         test "$debug" = "" || eval "$1"
845 }
846
847 test_run_ () {
848         test_cleanup=:
849         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
850         eval >&3 2>&4 "$1"
851         eval_ret=$?
852         eval >&3 2>&4 "$test_cleanup"
853         return 0
854 }
855
856 test_skip () {
857         test_count=$(($test_count+1))
858         to_skip=
859         for skp in $NOTMUCH_SKIP_TESTS
860         do
861                 case $this_test.$test_count in
862                 $skp)
863                         to_skip=t
864                         break
865                 esac
866                 case $this_test_bare.$test_count in
867                 $skp)
868                         to_skip=t
869                         break
870                 esac
871         done
872         case "$to_skip" in
873         t)
874                 test_report_skip_ "$@"
875                 ;;
876         *)
877                 test_check_missing_external_prereqs_ "$@"
878                 ;;
879         esac
880 }
881
882 test_check_missing_external_prereqs_ () {
883         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
884                 say_color skip >&1 "missing prerequisites: "
885                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
886                 test_report_skip_ "$@"
887         else
888                 false
889         fi
890 }
891
892 test_report_skip_ () {
893         test_reset_state_
894         say_color skip >&3 "skipping test:"
895         echo " $@" >&3
896         say_color skip "%-6s" "SKIP"
897         echo " $1"
898 }
899
900 test_subtest_known_broken () {
901         test_subtest_known_broken_=t
902 }
903
904 test_expect_success () {
905         exec 1>&6 2>&7          # Restore stdout and stderr
906         if [ -z "$inside_subtest" ]; then
907                 error "bug in the test script: test_expect_success without test_begin_subtest"
908         fi
909         inside_subtest=
910         test "$#" = 1 ||
911         error "bug in the test script: not 1 parameters to test_expect_success"
912
913         if ! test_skip "$test_subtest_name"
914         then
915                 test_run_ "$1"
916                 run_ret="$?"
917                 # test_run_ may update missing external prerequisites
918                 test_check_missing_external_prereqs_ "$@" ||
919                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
920                 then
921                         test_ok_
922                 else
923                         test_failure_ "$1"
924                 fi
925         fi
926 }
927
928 test_expect_code () {
929         exec 1>&6 2>&7          # Restore stdout and stderr
930         if [ -z "$inside_subtest" ]; then
931                 error "bug in the test script: test_expect_code without test_begin_subtest"
932         fi
933         inside_subtest=
934         test "$#" = 2 ||
935         error "bug in the test script: not 2 parameters to test_expect_code"
936
937         if ! test_skip "$test_subtest_name"
938         then
939                 test_run_ "$2"
940                 run_ret="$?"
941                 # test_run_ may update missing external prerequisites,
942                 test_check_missing_external_prereqs_ "$@" ||
943                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
944                 then
945                         test_ok_
946                 else
947                         test_failure_ "exit code $eval_ret, expected $1" "$2"
948                 fi
949         fi
950 }
951
952 # This is not among top-level (test_expect_success)
953 # but is a prefix that can be used in the test script, like:
954 #
955 #       test_expect_success 'complain and die' '
956 #           do something &&
957 #           do something else &&
958 #           test_must_fail git checkout ../outerspace
959 #       '
960 #
961 # Writing this as "! git checkout ../outerspace" is wrong, because
962 # the failure could be due to a segv.  We want a controlled failure.
963
964 test_must_fail () {
965         "$@"
966         test $? -gt 0 -a $? -le 129 -o $? -gt 192
967 }
968
969 # test_cmp is a helper function to compare actual and expected output.
970 # You can use it like:
971 #
972 #       test_expect_success 'foo works' '
973 #               echo expected >expected &&
974 #               foo >actual &&
975 #               test_cmp expected actual
976 #       '
977 #
978 # This could be written as either "cmp" or "diff -u", but:
979 # - cmp's output is not nearly as easy to read as diff -u
980 # - not all diff versions understand "-u"
981
982 test_cmp() {
983         $GIT_TEST_CMP "$@"
984 }
985
986 # This function can be used to schedule some commands to be run
987 # unconditionally at the end of the test to restore sanity:
988 #
989 #       test_expect_success 'test core.capslock' '
990 #               git config core.capslock true &&
991 #               test_when_finished "git config --unset core.capslock" &&
992 #               hello world
993 #       '
994 #
995 # That would be roughly equivalent to
996 #
997 #       test_expect_success 'test core.capslock' '
998 #               git config core.capslock true &&
999 #               hello world
1000 #               git config --unset core.capslock
1001 #       '
1002 #
1003 # except that the greeting and config --unset must both succeed for
1004 # the test to pass.
1005
1006 test_when_finished () {
1007         test_cleanup="{ $*
1008                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1009 }
1010
1011 test_done () {
1012         GIT_EXIT_OK=t
1013         test_results_dir="$TEST_DIRECTORY/test-results"
1014         mkdir -p "$test_results_dir"
1015         test_results_path="$test_results_dir/$this_test"
1016
1017         echo "total $test_count" >> $test_results_path
1018         echo "success $test_success" >> $test_results_path
1019         echo "fixed $test_fixed" >> $test_results_path
1020         echo "broken $test_broken" >> $test_results_path
1021         echo "failed $test_failure" >> $test_results_path
1022         echo "" >> $test_results_path
1023
1024         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1025
1026         if [ "$test_failure" = "0" ]; then
1027             if [ "$test_broken" = "0" ]; then
1028                 rm -rf "$remove_tmp"
1029             fi
1030             exit 0
1031         else
1032             exit 1
1033         fi
1034 }
1035
1036 emacs_generate_script () {
1037         # Construct a little test script here for the benefit of the user,
1038         # (who can easily run "run_emacs" to get the same emacs environment
1039         # for investigating any failures).
1040         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1041 #!/bin/sh
1042 export PATH=$PATH
1043 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1044
1045 # Here's what we are using here:
1046 #
1047 # --quick               Use minimal customization. This implies --no-init-file,
1048 #                       --no-site-file and (emacs 24) --no-site-lisp
1049 #
1050 # --directory           Ensure that the local elisp sources are found
1051 #
1052 # --load                Force loading of notmuch.el and test-lib.el
1053
1054 exec ${TEST_EMACS} --quick \
1055         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1056         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1057         "\$@"
1058 EOF
1059         chmod a+x "$TMP_DIRECTORY/run_emacs"
1060 }
1061
1062 test_emacs () {
1063         # test dependencies beforehand to avoid the waiting loop below
1064         missing_dependencies=
1065         test_require_external_prereq dtach || missing_dependencies=1
1066         test_require_external_prereq emacs || missing_dependencies=1
1067         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1068         test -z "$missing_dependencies" || return
1069
1070         if [ -z "$EMACS_SERVER" ]; then
1071                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1072                 if [ -f "$emacs_tests" ]; then
1073                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1074                 else
1075                         load_emacs_tests=
1076                 fi
1077                 server_name="notmuch-test-suite-$$"
1078                 # start a detached session with an emacs server
1079                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1080                 # or unknown) is given to dtach which assumes a minimally
1081                 # VT100-compatible terminal -- and emacs inherits that
1082                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1083                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1084                                 --no-window-system \
1085                                 $load_emacs_tests \
1086                                 --eval '(setq server-name \"$server_name\")' \
1087                                 --eval '(server-start)' \
1088                                 --eval '(orphan-watchdog $$)'" || return
1089                 EMACS_SERVER="$server_name"
1090                 # wait until the emacs server is up
1091                 until test_emacs '()' >/dev/null 2>/dev/null; do
1092                         sleep 1
1093                 done
1094         fi
1095
1096         # Clear test-output output file.  Most Emacs tests end with a
1097         # call to (test-output).  If the test code fails with an
1098         # exception before this call, the output file won't get
1099         # updated.  Since we don't want to compare against an output
1100         # file from another test, so start out with an empty file.
1101         rm -f OUTPUT
1102         touch OUTPUT
1103
1104         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1105 }
1106
1107 test_python() {
1108     # Note: if there is need to print debug information from python program,
1109     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1110     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1111         $NOTMUCH_PYTHON -B - > OUTPUT
1112 }
1113
1114 test_ruby() {
1115     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I "$NOTMUCH_BUILDDIR/bindings/ruby"> OUTPUT
1116 }
1117
1118 test_C () {
1119     local exec_file test_file
1120     exec_file="test${test_count}"
1121     test_file="${exec_file}.c"
1122     cat > ${test_file}
1123     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1124     echo "== stdout ==" > OUTPUT.stdout
1125     echo "== stderr ==" > OUTPUT.stderr
1126     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1127     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize > OUTPUT
1128 }
1129
1130 make_shim () {
1131     local base_name test_file shim_file
1132     base_name="$1"
1133     test_file="${base_name}.c"
1134     shim_file="${base_name}.so"
1135     cat > ${test_file}
1136     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1137 }
1138
1139 notmuch_with_shim () {
1140     local base_name shim_file
1141     base_name="$1"
1142     shift
1143     shim_file="${base_name}.so"
1144     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
1145 }
1146
1147 # Creates a script that counts how much time it is executed and calls
1148 # notmuch.  $notmuch_counter_command is set to the path to the
1149 # generated script.  Use notmuch_counter_value() function to get the
1150 # current counter value.
1151 notmuch_counter_reset () {
1152         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1153         if [ ! -x "$notmuch_counter_command" ]; then
1154                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1155                 cat >"$notmuch_counter_command" <<EOF || return
1156 #!/bin/sh
1157
1158 read count < "$notmuch_counter_state_path"
1159 echo \$((count + 1)) > "$notmuch_counter_state_path"
1160
1161 exec notmuch "\$@"
1162 EOF
1163                 chmod +x "$notmuch_counter_command" || return
1164         fi
1165
1166         echo 0 > "$notmuch_counter_state_path"
1167 }
1168
1169 # Returns the current notmuch counter value.
1170 notmuch_counter_value () {
1171         if [ -r "$notmuch_counter_state_path" ]; then
1172                 read count < "$notmuch_counter_state_path"
1173         else
1174                 count=0
1175         fi
1176         echo $count
1177 }
1178
1179 test_reset_state_ () {
1180         test -z "$test_init_done_" && test_init_
1181
1182         test_subtest_known_broken_=
1183         test_subtest_missing_external_prereq_=()
1184 }
1185
1186 # called once before the first subtest
1187 test_init_ () {
1188         test_init_done_=t
1189
1190         # skip all tests if there were external prerequisites missing during init
1191         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1192 }
1193
1194
1195 # Where to run the tests
1196 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1197
1198 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1199
1200 emacs_generate_script
1201
1202
1203 # Use -P to resolve symlinks in our working directory so that the cwd
1204 # in subprocesses like git equals our $PWD (for pathname comparisons).
1205 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1206
1207 if test "$verbose" = "t"
1208 then
1209         exec 4>&2 3>&1
1210 else
1211         exec 4>test.output 3>&4
1212 fi
1213
1214 for skp in $NOTMUCH_SKIP_TESTS
1215 do
1216         to_skip=
1217         for skp in $NOTMUCH_SKIP_TESTS
1218         do
1219                 case "$this_test" in
1220                 $skp)
1221                         to_skip=t
1222                         break
1223                 esac
1224                 case "$this_test_bare" in
1225                 $skp)
1226                         to_skip=t
1227                         break
1228                 esac
1229         done
1230         case "$to_skip" in
1231         t)
1232                 say_color skip >&3 "skipping test $this_test altogether"
1233                 say_color skip "skip all tests in $this_test"
1234                 test_done
1235         esac
1236 done
1237
1238 # Provide an implementation of the 'yes' utility
1239 yes () {
1240         if test $# = 0
1241         then
1242                 y=y
1243         else
1244                 y="$*"
1245         fi
1246
1247         while echo "$y"
1248         do
1249                 :
1250         done
1251 }
1252
1253 # Fix some commands on Windows
1254 case $(uname -s) in
1255 *MINGW*)
1256         # Windows has its own (incompatible) sort and find
1257         sort () {
1258                 /usr/bin/sort "$@"
1259         }
1260         find () {
1261                 /usr/bin/find "$@"
1262         }
1263         sum () {
1264                 md5sum "$@"
1265         }
1266         # git sees Windows-style pwd
1267         pwd () {
1268                 builtin pwd -W
1269         }
1270         # no POSIX permissions
1271         # backslashes in pathspec are converted to '/'
1272         # exec does not inherit the PID
1273         ;;
1274 *)
1275         test_set_prereq POSIXPERM
1276         test_set_prereq BSLASHPSPEC
1277         test_set_prereq EXECKEEPSPID
1278         ;;
1279 esac
1280
1281 test -z "$NO_PERL" && test_set_prereq PERL
1282 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1283
1284 # test whether the filesystem supports symbolic links
1285 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1286 rm -f y
1287
1288 # declare prerequisites for external binaries used in tests
1289 test_declare_external_prereq dtach
1290 test_declare_external_prereq emacs
1291 test_declare_external_prereq ${TEST_EMACSCLIENT}
1292 test_declare_external_prereq ${TEST_GDB}
1293 test_declare_external_prereq gpg
1294 test_declare_external_prereq openssl
1295 test_declare_external_prereq gpgsm
1296 test_declare_external_prereq ${NOTMUCH_PYTHON}
1297 test_declare_external_prereq xapian-metadata
1298 test_declare_external_prereq xapian-delve